package repostatus

import (
	"go.wit.com/gui"
	"go.wit.com/lib/gadgets"
)

type RepoStatus struct {
	ready   bool
	changed bool

	tags map[string]string

	window *gadgets.BasicWindow

	// a window to manage your .git tags
	TagsW *repoTags

	dirtyLabel  *gadgets.OneLiner
	readOnly    *gadgets.OneLiner
	goSumStatus *gadgets.OneLiner

	path      *gadgets.OneLiner
	goSrcPath *gadgets.OneLiner
	realPath  *gadgets.OneLiner

	currentBranch  *gadgets.OneLiner
	currentVersion *gadgets.OneLiner

	lasttag             *gadgets.OneLiner
	masterBranchVersion *gadgets.OneLiner
	develBranchVersion  *gadgets.OneLiner
	userBranchVersion   *gadgets.OneLiner

	mainWorkingName  *gadgets.OneLiner
	develWorkingName *gadgets.OneLiner
	userWorkingName  *gadgets.OneLiner

	develMergeB    *gui.Node
	mainMergeB     *gui.Node
	releaseVersion *gui.Node

	minor    *gadgets.BasicCombobox
	major    *gadgets.BasicCombobox
	revision *gadgets.BasicCombobox

	versionMessage       *gadgets.BasicEntry
	versionCmds          [][]string
	versionCmdOutput     *gadgets.OneLiner
	targetReleaseVersion *gadgets.OneLiner

	newversion *gui.Node

	gitBranchesGroup *gui.Node
	gitStatusGroup   *gui.Node
	gitCommandsGroup *gui.Node

	showBranchesButton  *gui.Node
	checkBranchesButton *gui.Node

	speed       *gadgets.OneLiner
	speedActual *gadgets.OneLiner

	gitConfig *GitConfig
	goConfig  GoConfig

	switchBranchB *gui.Node
	targetBranch  *gui.Node
}
